import java.awt.*;
import java.awt.event.*;
import java.applet.*;




public class Sokoban extends Applet
    implements KeyListener ,WindowListener{

    boolean estCeUneApplet = true;
    
    static int MAX_LUTINS = 5;
    /**
     * la carte du tableau
     */
    private Carte  laCarte;

    /**
     * le lutin du joueur
     */
    private Joueur joueur;
    
    /**
     * l'ensemble des lutins
     */
    private Lutin lesLutins[];

    /**
     * le nombre de lutins
     */
    private int nbLutins;

    class GestionClick extends MouseAdapter 
    {
	public void mousePressed(MouseEvent e)
	{
	    int x = e.getX() / Carte.ECHELLE;
	    int y = e.getY() / Carte.ECHELLE;
	    int i;
	    boolean occupe = false;
	    
	    if (nbLutins < MAX_LUTINS && ! laCarte.mur(x,y)) {
		for(i = 0; i < nbLutins && !occupe ; i++)
		    if (x == lesLutins[i].x && y == lesLutins[i].y)
			occupe = true;
		if (! occupe){
		    if (e.getButton() == 3)
			{
			if (joueur == null)
			    add_joueur(x, y);
			}
		    else add_caisse(x, y);
		    repaint();
		}
	    }
	    
	}
    }

    /**
     * pour dessiner le jeu de Sokoban
     * 
     * @param g le graphique du jeu
     */
    public void paint(Graphics g) 
    {
	int i;
	laCarte.paint(g);
	for (i=0; i < nbLutins; i++)
	  lesLutins[i].paint(g);
    } 

    /**
     * ajoute le pion du joueur  la positions (x,y)
     *
     * @param x l'abscisse
     *        y l'ordonne
     */
    public void add_joueur(int x, int y)
    {
	joueur = new Joueur(laCarte, x, y);
	lesLutins[nbLutins] = joueur;
	nbLutins++;
    }

    /**
     * ajoute une caisse  la positions (x,y)
     *
     * @param x l'abscisse
     * @param y l'ordonne
     */
    public void add_caisse(int x, int y)
    {
	Caisse c = new Caisse(laCarte, x, y);
	lesLutins[nbLutins] = c;
	nbLutins++;
    }

    /**
     * le constructeur du jeu Sokoban
     *
     */
    public void init() 
    { 	
	addKeyListener(this);
	addMouseListener(new GestionClick());
	
	/* creation de la carte */
	if (estCeUneApplet)
	    laCarte = new Carte("carte.txt",getDocumentBase());
	    else laCarte = new Carte("carte.txt",null);
	
	/* liste de lutins */
	lesLutins = new Lutin[MAX_LUTINS];
	nbLutins = 0;

	/* creation du joueur */
	//add_joueur(2,5);

	/* creation des caisses */
	//add_caisse(2,4);
	//add_caisse(4,5);
	//add_caisse(6,6);
	//add_caisse(7,5);

	/* la fentre */
	//setSize(200,200);
	setBackground(Color.black);
    }


    /* Clavier */
    public void keyPressed(KeyEvent e)
    {
	switch(e.getKeyCode())
	    {
	    case KeyEvent.VK_LEFT:
		joueur.gauche();
		repaint();
		break;
	    case KeyEvent.VK_RIGHT:
		joueur.droite();
		repaint();
		break;
	    case KeyEvent.VK_UP:
		joueur.haut();
		repaint();
		break;
	    case KeyEvent.VK_DOWN:
		joueur.bas();
		repaint();
		break;
	    default:
	    }
    }
    public void keyReleased(KeyEvent e){}
    public void keyTyped(KeyEvent e){}

    /* Fenetre */
    public void windowClosing(WindowEvent event) {
	System.exit(0);
    }

    public void windowClosed(WindowEvent event) {}
    public void windowDeiconified(WindowEvent event) {}
    public void windowIconified(WindowEvent event) {}
    public void windowActivated(WindowEvent event) {}
    public void windowDeactivated(WindowEvent event) {}
    public void windowOpened(WindowEvent event) {}


    /**
     * pour executer le jeu de Sokoban
     */
    public static void main(String args[]) {
	System.out.println("Dmarrage de l'application...");
	Frame frame = new Frame();
	Sokoban soko=new Sokoban();
	frame.addWindowListener (soko) ;
	frame.add("Center", soko);
	frame.setTitle("Sokoban");
	soko.estCeUneApplet = false;
	soko.init() ; soko.start();
	frame.setSize(250,250); frame.setVisible(true);
    }    
}
